package net.t2code.automatedMessages.config;

public enum Config {

    updateCheckOnJoin("plugin.updateCheck.onJoin", true, ConfigParam.BOOLEAN),
    updateCheckSeePreReleaseUpdates("plugin.updateCheck.seePreReleaseUpdates", true, ConfigParam.BOOLEAN),
    updateCheckTimeInterval("plugin.updateCheck.timeInterval", 60, ConfigParam.INTEGER),

    prefix("plugin.prefix", "", ConfigParam.STRING),

    msgReloadStart("plugin.messages.reloadStart", "Reload start", ConfigParam.STRING),
    msgReloadEnd("plugin.messages.reloadEnd", "Reload end", ConfigParam.STRING),

    message("messages",
            "messages.KEY.enable", false,
            "messages.KEY.message", "",
            "messages.KEY.intervalInMin", 0,
            "messages.KEY.useCronJob.enable", false,
            "messages.KEY.useCronJob.value", "",
            ConfigParam.MESSAGE
    );

    public String path;
    public String valueString;
    public Boolean valueBoolean;
    public Integer valueInteger;

    public String msgPath;
    public String msgEnablePath;
    public Boolean msgEnable;

    public String msgMsgPath;
    public String msgMsg;
    public String msgIntervalPath;
    public Integer msgInterval;
    public String msgCronJobPath;
    public Boolean msgCronJob;
    public String msgCronJobStringPath;
    public String msgCronJobString;

    public ConfigParam configParam;

    Config(String path, String value, ConfigParam cEnum) {
        this.path = path;
        this.valueString = value;
        this.configParam = cEnum;
    }

    Config(String path, Integer value, ConfigParam cEnum) {
        this.path = path;
        this.valueInteger = value;
        this.configParam = cEnum;
    }

    Config(String path, Boolean value, ConfigParam cEnum) {
        this.path = path;
        this.valueBoolean = value;
        this.configParam = cEnum;
    }

    Config(String msgPath,
           String msgEnablePath, Boolean msgEnable,
           String msgMsgPath, String msgMsg,
           String msgIntervalPath, Integer msgInterval,
           String msgCronJobPath, Boolean msgCronJob,
           String msgCronJobStringPath, String msgCronJobString,
           ConfigParam configParam) {
        this.msgPath = msgPath;
        this.msgEnablePath = msgEnablePath;
        this.msgEnable = msgEnable;
        this.msgMsgPath = msgMsgPath;
        this.msgMsg = msgMsg;
        this.msgIntervalPath = msgIntervalPath;
        this.msgInterval = msgInterval;
        this.msgCronJobPath = msgCronJobPath;
        this.msgCronJob = msgCronJob;
        this.msgCronJobStringPath = msgCronJobStringPath;
        this.msgCronJobString = msgCronJobString;
        this.configParam = configParam;
    }
}
